<?php
/*
* Configuration, translations and database converter
* Script upgrade Quick.Cms v3.x to v4.0
* Before run please read converter-read-me.txt
*/

error_reporting( E_ALL ^ E_NOTICE );
require 'core/libraries/trash.php';
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Quick.Cms v4.x converter</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta name="Description" content="" />
  <meta name="Keywords" content="" />
  <meta name="Author" content="OpenSolution.org" />
  <style type="text/css">
    body,h1,h2,h3,h4,h5,h6,p,form,fieldset,img,td,th{margin:0;padding:0;border:0}
    body{background:#eae9e9;font:12px arial;color:#000;}
    a{color:#ca2222;text-decoration:underline;}
    a:hover{color:#000;text-decoration:underline;}

    input{font:11px arial;}
    .input, select{border:1px solid #666;font:11px arial;}
    .input:focus, select:focus{background:#ffebc1;}
    #converter{width:510px;margin:100px auto 0;padding:12px;background:#faf9f9;color:#fff;border:1px solid #dedbdb;-moz-border-radius:15px;border-radius:15px;}
    #body{padding:0 12px;background:#870707;-moz-border-radius:10px;border-radius:10px;}
    #logo{text-align:center;}
    #converter .description{padding:10px 0 5px;font-size:12px;}
    #converter form{margin-left:30px;padding-bottom:20px;font-size:14px;}
    #converter td{padding:5px;}
    #converter .input{width:200px;font-size:18px;}
    #converter .submit{background:#fff;font-size:13px;font-weight:bold;}
    #help{padding:10px 0 0 10px;}
    .msg{text-align:center;font-size:15px;font-weight:bold;padding:50px 0;}
    .msg a{color:#fff;}
    .msg a:hover{color:#000;}

    #converter form.step1 table{margin-top:10px;}
    #converter form.step2{font-size:12px;}
    #converter form.step2 label{margin-right:20px;}
    #converter form.step2 #options label{display:block;}
  </style>
</head>
<body>
  <div id="converter">
    <div id="body">
      <div id="logo"><a href="?p="><img src="http://opensolution.org/os/templates/img/logo_os_converter.jpg" alt="OpenSolution.org"/></a></div>
<?php
if( isset( $_POST['sOldDir'] ) && !empty( $_POST['sOldDir'] ) ){
  $sOldDir = trim( $_POST['sOldDir'] );
  if( substr( $sOldDir, strlen( $sOldDir ) - 1 ) != '/' )
    $sOldDir .= '/';
  if( !is_dir( $sOldDir ) && !is_dir( $sOldDir.'/db' ) || !is_dir( $sOldDir.'/lang' ) || !is_dir( $sOldDir.'/config' ) ){
    $sOldDir = null;
  }
}

define( 'DB_NEW', 'database/' );
if( isset( $sOldDir ) )
  define( 'DB_OLD', $sOldDir );

if( isset( $_POST['aLangs'] ) && isset( $sOldDir ) ) {
  echo '<div class="msg">Operation ended successfully! :)<br /><br />Delete file "converter.php" from your server<br /><br />IGNORE ALL ERRORS STARTED WITH: Notice: Constant.<br />Other errors report on <a href="http://opensolution.org/Quick.Cms/forum/">forum &raquo;</a></div>';

  $iChmod = 0777;
  $aLangs = $_POST['aLangs'];

  if( isset( $_POST['iCopyConfig'] ) ){
    /*
    * Configuration convertion
    */
    convertConfig( $aLangs );
  }

  if( isset( $_POST['iCopyDatabase'] ) ){
    /*
    * Database convertion
    */
    foreach( $aLangs as $sLang ){
      convertDatabaseLang( $sLang );
    }
  }

  if( isset( $_POST['iCopyTranslations'] ) ){
    /*
    * Translations convertion
    */
    convertLangs( $aLangs );
  }
}
elseif( isset( $sOldDir ) ) {

  /*
  * All available translations
  */
  $aLangs = throwLangs( );
  if( isset( $aLangs ) && is_array( $aLangs ) && count( $aLangs ) > 0 ){
    echo '<form method="post" action="" name="form" class="step2">
    <div class="description">
      Choose languages which you want to be converted to new version:
    </div>
    <input type="hidden" name="sOldDir" class="input" value="'.$sOldDir.'" />';
    foreach( $aLangs as $sLang ){
      echo '<label><input type="checkbox" name="aLangs['.$sLang.']" value="'.$sLang.'" /> '.$sLang.'</label>';
    }
    echo '<br /><br />
      <div class="description">
        From old version (choose options):
      </div>
      <div id="options">
        <label><input type="checkbox" name="iCopyDatabase" value="1" checked="checked" /> copy database</label>
        <label><input type="checkbox" name="iCopyConfig" value="1" /> copy configuration</label>
        <label><input type="checkbox" name="iCopyTranslations" value="1" /> copy translations</label>
      </div>
      <br /><br />
      <div><input type="submit" value="next step &raquo;" class="submit" /></div>
    </form>';
  }
  else{
    echo '<div class="msg">Error: no language files</div>';
  }
}
else{
  echo '<form method="post" action="" name="form" class="step1">
    <div class="description">
      Thank you for download new version of Quick.Cms.<br /><br />
      Using this converter you can import data from Quick.Cms v3.x to v4.x:<br />
      - put converter script to new version main directory<br />
      - create directory for example "_old/" in new version directory and then type it below<br />
      - copy directories "db/", "config/", "lang/" from old version to that directory
    </div>
    <table>
      <tr><td>Old version directory:</td><td><input type="text" name="sOldDir" class="input" value="_old/" /></td></tr>
      <tr><td>&nbsp;</td><td><input type="submit" value="next step &raquo;" class="submit" /></td></tr>
    </table>
  </form>
  ';
}

?><?php
/*
* Functions 
*/
function throwLangs( ){
  foreach( new DirectoryIterator( DB_OLD.'lang/' ) as $oFileDir ) {
    if( $oFileDir->isFile( ) && strstr( $oFileDir->getFilename( ), '.php' ) ){
      $sLang = substr( $oFileDir->getFilename( ), 0, 2 );
      $aLangs[$sLang] = $sLang;
    }
  } // end foreach
  return $aLangs;
}

function convertLangs( $aLangs ){
  if( isset( $aLangs ) ){
    foreach( $aLangs as $sLang ){
      if( is_file( DB_OLD.'lang/'.$sLang.'.php' ) ){
        if( !is_file( DB_NEW.'translations/'.$sLang.'.php' ) ){
          copy( DB_NEW.'translations/en.php', DB_NEW.'translations/'.$sLang.'.php' );
          chmod( DB_NEW.'translations/'.$sLang.'.php', $GLOBALS['iChmod'] );
        }
        $aChangeLang = throwVariablesToChange( DB_OLD.'lang/'.$sLang.'.php', DB_NEW.'translations/'.$sLang.'.php', 'lang' );
        if( isset( $aChangeLang ) ){
          saveVariables( $aChangeLang, DB_NEW.'translations/'.$sLang.'.php', 'lang' );
        }
      }
    }
  }
}

function convertConfig( $aLangs ){
  $aChangeGeneral = throwVariablesToChange( DB_OLD.'config/general.php', DB_NEW.'config/general.php' );
  if( isset( $aChangeGeneral ) ){
    saveVariables( $aChangeGeneral, DB_NEW.'config/general.php' );
  }
  if( isset( $aLangs ) ){
    foreach( $aLangs as $sLang ){
      if( is_file( DB_OLD.'config/lang_'.$sLang.'.php' ) ){
        if( !is_file( DB_NEW.'config/lang_'.$sLang.'.php' ) ){
          copy( DB_NEW.'config/lang_en.php', DB_NEW.'config/lang_'.$sLang.'.php' );
          chmod( DB_NEW.'config/lang_'.$sLang.'.php', $GLOBALS['iChmod'] );
        }
        $aChangeLang = throwVariablesToChange( DB_OLD.'config/lang_'.$sLang.'.php', DB_NEW.'config/lang_'.$sLang.'.php' );
        if( isset( $aChangeLang ) ){
          saveVariables( $aChangeLang, DB_NEW.'config/lang_'.$sLang.'.php' );
        }
      }
    }
  }
}

function convertDatabaseLang( $sLang ){
  if( !function_exists( 'pages' ) )
    include DB_OLD.'db/_pages.def.php';
  if( !function_exists( 'pages_ext' ) )
    include DB_OLD.'db/_pages_ext.def.php';
  if( !function_exists( 'pages_files' ) )
    include DB_OLD.'db/_pages_files.def.php';
  include DB_NEW.'_fields.php';

  if( is_file( DB_OLD.'db/'.$sLang.'_pages_files.php' ) ){
    $aFile = file( DB_OLD.'db/'.$sLang.'_pages_files.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aData[] = pages_files( $aExp );
    } // end for
    file_put_contents( DB_NEW.$sLang.'_pages_files.php', '<?php exit; ?>'."\n".serialize( $aData ) );
    unset( $aData, $aFile );
  }

  if( is_file( DB_OLD.'db/'.$sLang.'_pages.php' ) && is_file( DB_OLD.'db/'.$sLang.'_pages_ext.php' ) ){
    $aPages = null;
    $aPagesFinal = null;

    $aFile = file( DB_OLD.'db/'.$sLang.'_pages_ext.php' );
    $iCount = count( $aFile );
    $aPages = null;
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aPages[$aExp[0]] = pages_ext( $aExp );
    } // end for

    unset( $aFile );

    $aFile = file( DB_OLD.'db/'.$sLang.'_pages.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      if( !is_numeric( $aExp[1] ) )
        $aExp[1] = 0;
      $aPagesFinal[] = array_merge( pages( $aExp ), $aPages[$aExp[0]] );
      $aPages[$aExp[0]] = null;
    } // end for

    file_put_contents( DB_NEW.$sLang.'_pages.php', '<?php exit; ?>'."\n".serialize( $aPagesFinal ) );
    unset( $aData, $aPages, $aPagesFinal, $aFile );
  }
}

function saveVariables( $aForm, $sFile, $sVariable = 'config' ){
  $aFile = file( $sFile );
  $iCount = count( $aFile );
  $rFile = fopen( $sFile, 'w' );

  for( $i = 0; $i < $iCount; $i++ ){
    foreach( $aForm as $sKey => $sValue ){
      if( preg_match( '/'.$sVariable."\['".$sKey."'\]".' /', $aFile[$i] ) && strstr( $aFile[$i], '=' ) ){
        if( !is_bool( $sValue ) && !is_numeric( $sValue ) && !is_array( $sValue ) && !strstr( $sValue, 'Array(' ) ){
          $sValue = changeSpecialChars( $sValue );
          $sValue = str_replace( '"', '&quot;', $sValue );
          $sValue = stripslashes( $sValue );
        }
        
        if( is_array( $sValue ) ){
          $aFile[$i] = "\$".$sVariable."['".$sKey."'] = ".str_replace( "\n", '', var_export( $sValue, true ) ).";\n";
        }
        elseif( ( is_numeric( $sValue ) || preg_match( '/^(true|false|null)$/', $sValue ) == true ) && !preg_match( '/0[0-9]+/', $sValue ) ){
          $aFile[$i] = "\$".$sVariable."['".$sKey."'] = ".$sValue.";\n";
        }
        elseif( is_bool( $sValue ) ){
          if( $sValue === true )
            $aFile[$i] = "\$".$sVariable."['".$sKey."'] = true;\n";
          else
            $aFile[$i] = "\$".$sVariable."['".$sKey."'] = false;\n";
        }
        else
          $aFile[$i] = "\$".$sVariable."['".$sKey."'] = \"".$sValue."\";\n";
      }
    } // end foreach

    fwrite( $rFile, $aFile[$i] );

  } // end for
  fclose( $rFile );
}

function throwVariablesToChange( $sFileOld, $sFileNew, $sVariable = 'config' ){
  include $sFileOld;
  $aOld = $$sVariable;
  include $sFileNew;
  $aNew = $$sVariable;
  foreach( $aNew as $sKey => $sValue ){
    if( isset( $aOld[$sKey] ) && $aOld[$sKey] != $sValue && !is_array( $aOld[$sKey] ) && !preg_match( '/dir|config|version/i', $sKey ) ){
      $aChange[$sKey] = $aOld[$sKey];
    }
  } // end foreach
  if( isset( $aOld['pages_images_sizes'] ) ){
    $aChange['pages_images_sizes'] = $aOld['pages_images_sizes'];
  }
  if( isset( $aOld['default_lang'] ) ){
    $aChange['admin_lang'] = $aOld['default_lang'];
  }
  
  if( isset( $aChange ) )
    return $aChange;
}
?>